automake-patches
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

Re: RFE: make automake's output deterministic


From: Ralf Wildenhues
Subject: Re: RFE: make automake's output deterministic
Date: Thu, 10 Jan 2008 20:54:34 +0100
User-agent: Mutt/1.5.13 (2006-08-11)

Hello Bruno,

* Bruno Haible wrote on Tue, Jan 08, 2008 at 12:34:59AM CET:
> 
> > It would be nice to have
> > a test to expose this to go along with this change if possible.  Can you
> > provide a recipe to reproduce the ordering change?
> 
> On Linux/x86, with autoconf-2.61, m4-1.4.10, automake-1.10, the following
> recipe does it for me:

Thank you.  I have spent some time trying to reproduce this over here,
but couldn't (perl 5.8.7, by the way).  So I think I need to rely on you
to test the test as well.

When you apply the following patch to Automake, and undo my fix,
does that expose the failure for you?  You can try with
  make && cd tests && make check VERBOSE=yes TESTS=output-order.test

Thanks,
Ralf

diff --git a/ChangeLog b/ChangeLog
index 766941a..e123fd5 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+2008-01-10  Bruno Haible  <address@hidden>
+           Ralf Wildenhues  <address@hidden>
+
+       * tests/output-order.test: New test, for the stable output fix.
+       * tests/Makefile.am: Update.
+
 2008-01-08  Ralf Wildenhues  <address@hidden>
 
        * Makefile.am (dist-hook): New, ensure world-executable tests.
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 80d3d71..db40acc 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -421,6 +421,7 @@ output10.test \
 output11.test \
 output12.test \
 output13.test \
+output-order.test \
 overrid.test \
 parse.test \
 percent.test \
diff --git a/tests/Makefile.in b/tests/Makefile.in
index dc18bab..ceff3f4 100644
--- a/tests/Makefile.in
+++ b/tests/Makefile.in
@@ -570,6 +570,7 @@ output10.test \
 output11.test \
 output12.test \
 output13.test \
+output-order.test \
 overrid.test \
 parse.test \
 percent.test \
diff --git a/tests/output-order.test b/tests/output-order.test
new file mode 100755
index 0000000..e55ef36
--- /dev/null
+++ b/tests/output-order.test
@@ -0,0 +1,52 @@
+#! /bin/sh
+# Copyright (C) 2008  Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# Test that `automake -a' output order is stable.
+# From report by Bruno Haible.
+
+. ./defs || exit 1
+
+set -e
+
+cat >>configure.in <<'END'
+AC_OUTPUT
+END
+
+: >Makefile.am
+: >AUTHORS
+: >ChangeLog
+: >NEWS
+: >README
+
+cat >.autom4te.cfg <<'END'
+begin-language: "Autoconf"
+args: --no-cache
+end-language: "Autoconf"
+begin-language: "Autoconf-without-aclocal-m4"
+args: --no-cache
+end-language: "Autoconf-without-aclocal-m4"
+END
+
+$ACLOCAL
+$AUTOCONF
+rm -f missing install-sh
+$AUTOMAKE --add-missing --copy 2>stderr
+cat stderr >&2
+
+for i in 1 2 3 4 5 6; do
+  rm -f missing install-sh INSTALL COPYING
+  $AUTOMAKE --add-missing --copy 2>&1 >/dev/null | diff - stderr
+done




reply via email to

[Prev in Thread] Current Thread [Next in Thread]